/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.model.BooleanValue;
import org.openxma.dsl.pom.PomPackage;

import org.openxma.dsl.pom.model.Button;
import org.openxma.dsl.pom.model.ComposedElement;
import org.openxma.dsl.pom.model.ContentAlignment;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.IElementOnWhichCanBeAttached;
import org.openxma.dsl.pom.model.IElementWithLayoutData;
import org.openxma.dsl.pom.model.IGuiElementWithEvent;
import org.openxma.dsl.pom.model.ImageUri;
import org.openxma.dsl.pom.model.LabelText;
import org.openxma.dsl.pom.model.LayoutDataProperty;
import org.openxma.dsl.pom.model.SimpleElement;
import org.openxma.dsl.pom.model.TabableFlag;
import org.openxma.dsl.pom.model.StringDefinition;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Button</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getLayoutProperties <em>Layout Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getTabableFlag <em>Tabable Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getLabelText <em>Label Text</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getImageUri <em>Image Uri</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getImageUriReference <em>Image Uri Reference</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getAlignment <em>Alignment</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ButtonImpl#getToggle <em>Toggle</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ButtonImpl extends IGuiElementWithEventImpl implements Button {
    /**
	 * The cached value of the '{@link #getLayoutProperties() <em>Layout Properties</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLayoutProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<LayoutDataProperty> layoutProperties;

				/**
	 * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFieldFlags()
	 * @generated
	 * @ordered
	 */
	protected EList<FieldFlag> fieldFlags;

				/**
	 * The cached value of the '{@link #getTabableFlag() <em>Tabable Flag</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTabableFlag()
	 * @generated
	 * @ordered
	 */
	protected TabableFlag tabableFlag;

				/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

				/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
				 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
				protected String name = NAME_EDEFAULT;

				/**
	 * The cached value of the '{@link #getLabelText() <em>Label Text</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getLabelText()
	 * @generated
	 * @ordered
	 */
    protected LabelText labelText;

				/**
	 * The default value of the '{@link #getImageUri() <em>Image Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getImageUri()
	 * @generated
	 * @ordered
	 */
    protected static final String IMAGE_URI_EDEFAULT = null;

				/**
	 * The cached value of the '{@link #getImageUri() <em>Image Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getImageUri()
	 * @generated
	 * @ordered
	 */
    protected String imageUri = IMAGE_URI_EDEFAULT;

				/**
	 * The cached value of the '{@link #getImageUriReference() <em>Image Uri Reference</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getImageUriReference()
	 * @generated
	 * @ordered
	 */
    protected ImageUri imageUriReference;

				/**
	 * The default value of the '{@link #getAlignment() <em>Alignment</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getAlignment()
	 * @generated
	 * @ordered
	 */
    protected static final ContentAlignment ALIGNMENT_EDEFAULT = ContentAlignment.DEFAULT;

				/**
	 * The cached value of the '{@link #getAlignment() <em>Alignment</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getAlignment()
	 * @generated
	 * @ordered
	 */
    protected ContentAlignment alignment = ALIGNMENT_EDEFAULT;

				/**
	 * The default value of the '{@link #getToggle() <em>Toggle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToggle()
	 * @generated
	 * @ordered
	 */
	protected static final BooleanValue TOGGLE_EDEFAULT = BooleanValue.NULL;

				/**
	 * The cached value of the '{@link #getToggle() <em>Toggle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToggle()
	 * @generated
	 * @ordered
	 */
	protected BooleanValue toggle = TOGGLE_EDEFAULT;

				/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ButtonImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return PomPackage.Literals.BUTTON;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__NAME, oldName, name));
	}

				/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public LabelText getLabelText() {
		return labelText;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetLabelText(LabelText newLabelText, NotificationChain msgs) {
		LabelText oldLabelText = labelText;
		labelText = newLabelText;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__LABEL_TEXT, oldLabelText, newLabelText);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setLabelText(LabelText newLabelText) {
		if (newLabelText != labelText) {
			NotificationChain msgs = null;
			if (labelText != null)
				msgs = ((InternalEObject)labelText).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.BUTTON__LABEL_TEXT, null, msgs);
			if (newLabelText != null)
				msgs = ((InternalEObject)newLabelText).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.BUTTON__LABEL_TEXT, null, msgs);
			msgs = basicSetLabelText(newLabelText, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__LABEL_TEXT, newLabelText, newLabelText));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String getImageUri() {
		return imageUri;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setImageUri(String newImageUri) {
		String oldImageUri = imageUri;
		imageUri = newImageUri;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__IMAGE_URI, oldImageUri, imageUri));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ImageUri getImageUriReference() {
		if (imageUriReference != null && imageUriReference.eIsProxy()) {
			InternalEObject oldImageUriReference = (InternalEObject)imageUriReference;
			imageUriReference = (ImageUri)eResolveProxy(oldImageUriReference);
			if (imageUriReference != oldImageUriReference) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.BUTTON__IMAGE_URI_REFERENCE, oldImageUriReference, imageUriReference));
			}
		}
		return imageUriReference;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ImageUri basicGetImageUriReference() {
		return imageUriReference;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setImageUriReference(ImageUri newImageUriReference) {
		ImageUri oldImageUriReference = imageUriReference;
		imageUriReference = newImageUriReference;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__IMAGE_URI_REFERENCE, oldImageUriReference, imageUriReference));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public ContentAlignment getAlignment() {
		return alignment;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setAlignment(ContentAlignment newAlignment) {
		ContentAlignment oldAlignment = alignment;
		alignment = newAlignment == null ? ALIGNMENT_EDEFAULT : newAlignment;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__ALIGNMENT, oldAlignment, alignment));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BooleanValue getToggle() {
		return toggle;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToggle(BooleanValue newToggle) {
		BooleanValue oldToggle = toggle;
		toggle = newToggle == null ? TOGGLE_EDEFAULT : newToggle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__TOGGLE, oldToggle, toggle));
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<LayoutDataProperty> getLayoutProperties() {
		if (layoutProperties == null) {
			layoutProperties = new EObjectContainmentEList<LayoutDataProperty>(LayoutDataProperty.class, this, PomPackage.BUTTON__LAYOUT_PROPERTIES);
		}
		return layoutProperties;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FieldFlag> getFieldFlags() {
		if (fieldFlags == null) {
			fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.BUTTON__FIELD_FLAGS);
		}
		return fieldFlags;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TabableFlag getTabableFlag() {
		return tabableFlag;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTabableFlag(TabableFlag newTabableFlag, NotificationChain msgs) {
		TabableFlag oldTabableFlag = tabableFlag;
		tabableFlag = newTabableFlag;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__TABABLE_FLAG, oldTabableFlag, newTabableFlag);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTabableFlag(TabableFlag newTabableFlag) {
		if (newTabableFlag != tabableFlag) {
			NotificationChain msgs = null;
			if (tabableFlag != null)
				msgs = ((InternalEObject)tabableFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.BUTTON__TABABLE_FLAG, null, msgs);
			if (newTabableFlag != null)
				msgs = ((InternalEObject)newTabableFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.BUTTON__TABABLE_FLAG, null, msgs);
			msgs = basicSetTabableFlag(newTabableFlag, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.BUTTON__TABABLE_FLAG, newTabableFlag, newTabableFlag));
	}

				/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PomPackage.BUTTON__LAYOUT_PROPERTIES:
				return ((InternalEList<?>)getLayoutProperties()).basicRemove(otherEnd, msgs);
			case PomPackage.BUTTON__FIELD_FLAGS:
				return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
			case PomPackage.BUTTON__TABABLE_FLAG:
				return basicSetTabableFlag(null, msgs);
			case PomPackage.BUTTON__LABEL_TEXT:
				return basicSetLabelText(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PomPackage.BUTTON__LAYOUT_PROPERTIES:
				return getLayoutProperties();
			case PomPackage.BUTTON__FIELD_FLAGS:
				return getFieldFlags();
			case PomPackage.BUTTON__TABABLE_FLAG:
				return getTabableFlag();
			case PomPackage.BUTTON__NAME:
				return getName();
			case PomPackage.BUTTON__LABEL_TEXT:
				return getLabelText();
			case PomPackage.BUTTON__IMAGE_URI:
				return getImageUri();
			case PomPackage.BUTTON__IMAGE_URI_REFERENCE:
				if (resolve) return getImageUriReference();
				return basicGetImageUriReference();
			case PomPackage.BUTTON__ALIGNMENT:
				return getAlignment();
			case PomPackage.BUTTON__TOGGLE:
				return getToggle();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
				@Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PomPackage.BUTTON__LAYOUT_PROPERTIES:
				getLayoutProperties().clear();
				getLayoutProperties().addAll((Collection<? extends LayoutDataProperty>)newValue);
				return;
			case PomPackage.BUTTON__FIELD_FLAGS:
				getFieldFlags().clear();
				getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
				return;
			case PomPackage.BUTTON__TABABLE_FLAG:
				setTabableFlag((TabableFlag)newValue);
				return;
			case PomPackage.BUTTON__NAME:
				setName((String)newValue);
				return;
			case PomPackage.BUTTON__LABEL_TEXT:
				setLabelText((LabelText)newValue);
				return;
			case PomPackage.BUTTON__IMAGE_URI:
				setImageUri((String)newValue);
				return;
			case PomPackage.BUTTON__IMAGE_URI_REFERENCE:
				setImageUriReference((ImageUri)newValue);
				return;
			case PomPackage.BUTTON__ALIGNMENT:
				setAlignment((ContentAlignment)newValue);
				return;
			case PomPackage.BUTTON__TOGGLE:
				setToggle((BooleanValue)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case PomPackage.BUTTON__LAYOUT_PROPERTIES:
				getLayoutProperties().clear();
				return;
			case PomPackage.BUTTON__FIELD_FLAGS:
				getFieldFlags().clear();
				return;
			case PomPackage.BUTTON__TABABLE_FLAG:
				setTabableFlag((TabableFlag)null);
				return;
			case PomPackage.BUTTON__NAME:
				setName(NAME_EDEFAULT);
				return;
			case PomPackage.BUTTON__LABEL_TEXT:
				setLabelText((LabelText)null);
				return;
			case PomPackage.BUTTON__IMAGE_URI:
				setImageUri(IMAGE_URI_EDEFAULT);
				return;
			case PomPackage.BUTTON__IMAGE_URI_REFERENCE:
				setImageUriReference((ImageUri)null);
				return;
			case PomPackage.BUTTON__ALIGNMENT:
				setAlignment(ALIGNMENT_EDEFAULT);
				return;
			case PomPackage.BUTTON__TOGGLE:
				setToggle(TOGGLE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PomPackage.BUTTON__LAYOUT_PROPERTIES:
				return layoutProperties != null && !layoutProperties.isEmpty();
			case PomPackage.BUTTON__FIELD_FLAGS:
				return fieldFlags != null && !fieldFlags.isEmpty();
			case PomPackage.BUTTON__TABABLE_FLAG:
				return tabableFlag != null;
			case PomPackage.BUTTON__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case PomPackage.BUTTON__LABEL_TEXT:
				return labelText != null;
			case PomPackage.BUTTON__IMAGE_URI:
				return IMAGE_URI_EDEFAULT == null ? imageUri != null : !IMAGE_URI_EDEFAULT.equals(imageUri);
			case PomPackage.BUTTON__IMAGE_URI_REFERENCE:
				return imageUriReference != null;
			case PomPackage.BUTTON__ALIGNMENT:
				return alignment != ALIGNMENT_EDEFAULT;
			case PomPackage.BUTTON__TOGGLE:
				return toggle != TOGGLE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == IElementWithLayoutData.class) {
			switch (derivedFeatureID) {
				case PomPackage.BUTTON__LAYOUT_PROPERTIES: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES;
				case PomPackage.BUTTON__FIELD_FLAGS: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS;
				case PomPackage.BUTTON__TABABLE_FLAG: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG;
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == SimpleElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == IElementWithLayoutData.class) {
			switch (baseFeatureID) {
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES: return PomPackage.BUTTON__LAYOUT_PROPERTIES;
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS: return PomPackage.BUTTON__FIELD_FLAGS;
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG: return PomPackage.BUTTON__TABABLE_FLAG;
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == SimpleElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

				/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", imageUri: ");
		result.append(imageUri);
		result.append(", alignment: ");
		result.append(alignment);
		result.append(", toggle: ");
		result.append(toggle);
		result.append(')');
		return result.toString();
	}

} //ButtonImpl
